# 2- Te-Form - basics

## Rule

### Verbs

The easiest way to identify whether to use て or で is by looking at the preceding kana.
If the plain (dictionary) form of the verb finishes in ぐ, ぬ, ぶ, or む, then で will be used.
る-Verbs never use で.

| Ending              | Ending Te-Form | Verb           | Te-Form                       | Hiragana            |
| ------------------- | -------------- | -------------- | ----------------------------- | ------------------- |
| **る verbs**         |                |                |                               |                     |
| (い・え)る              | て              | 食べる            | 食べ==て==                       | たべて                 |
| **う verbs**         |                |                |                               |                     |
| う<br>つ<br>る         | <br>って<br>     | 歌う<br>打つ<br>座る | 歌==って==<br>打==って==<br>座==って== | うたって<br>うって<br>すわって |
| む<br>ぶ<br>ぬ         | <br>んで         | 休む<br>飛ぶ<br>死ぬ | 休==んで==<br>飛==んで==<br>死==んで== | やすんで<br>とんで<br>しんで  |
| く                   | いて             | 歩く             | 歩==いて==                       | あるいて                |
| ぐ                   | いで             | 泳ぐ             | 泳==いで==                       | およいで                |
| す                   | して             | 話す             | 話==して==                       | はなして                |
| **Irregular Verbs** |                |                |                               |                     |
|                     |                | する             | し==て==                        |                     |
|                     |                | 行く             | 行==って==                       | いって                 |
|                     |                | 来る             | 来==て==                        | きて                  |

### Adjectives and nouns

| Form                 | Word  | Word Te-Form |
| -------------------- | ----- | ------------ |
| **いA** + ~~い~~ く + て | おもしろい | おもしろ==くて==   |
| **なA** + で           | しずか   | しずか==で==     |
| **N** + で            | 猫     | 猫==で==       |

### Song

A common way to remember this form is by a song. Here is one sung by Hatsune Miku.

![Te Song](https://www.youtube.com/watch?v=Cj-P-nEPoe0)

| Ending | Te-Form |
| ------ | ------- |
| う・つ・る  | って      |
| む・ぶ・ぬ  | んで      |
| く      | いて      |
| ぐ      | いで      |
| いく     | いって     |
| くる     | きて      |
| する     | して      |
| す      | して      |

## Basic functions

### Connection

The most basic function of the Te-Form: form connection between **verbs**.

> [!info] Example
> 食べ==て=={寝|ね}る。
> To eat, then sleep.

This also works with **いA**, **なA**, and **nouns**.

> [!info] Example
> あの{自転車|じてんしゃ}は{便利|べんり}==で=={軽|かる}い。
> That bicycle is useful and light.

### Reasons

Used primarily for reasons beyond control of the speaker.

> [!info] Example
> 大雨==で==バスが止まりました。
> The bus stopped with rain. (the reason is the rain)

### Manners

Highlights something being used, whether a tool, a circumstance, a situation, etc.

> [!info] Examples
> 私はご{飯|はん}を{急|いそ}い==で==食べる。
> I eat food in a hurry.
> 
> ハサミ==で=={野菜|やさい}を{切|き}ります。
> I cut my vegetables using scissors.

## Sequence and non-sequence

Only for **verbs**.

### て sequence

Used to list a sequence of events that happen one after another. Must be used for ordered sequence of what is being said!

> [!info] Example
> パンを買==って==、食べた。
> I bought some bread, then ate it.

### て non-sequence

The particle can also contrast things that have some sort of relationship. It can mean something like "and" or "while", but is not really similar to "but": it always has the same weight in the sentence, as opposed to expressions like けど・のに, etc.

> [!info] Examples
> 朝は雨が{降|ふ}==って=={夕方|ゆう|がた}は{晴|は}れた。
> It rained this morning, **and** then it cleared up in the afternoon. (there is no particular emphasis on either event).
>
> 朝は雨が降った==けど==夕方は晴れた。
> It rained this morning, **but then** it cleared up in the afternoon. (there is emphasis on the fact that it stopped raining).

### てから

Used to say that something will happen after something else : "after doing (A), (B)".
Only for **verbs**.

> [!info] Example
> {洗濯|せん|たく}をし==てから==、出かける。
> After doing the laundry, I will go out.

⚠ Simple present (るから) and past (たから) have a meaning closer to "because" or "since".

## States

### ている form

| Plain | Polite |
| ----- | ------ |
| ている   | ています   |
| てる    | てます    |

ている is often shortened to てる. This applies to all tenses, including てる, てて, てた, and even てます.
Only for **verbs**.

Sometimes ている can become しとる (like in manga).

#### 1/ State of existence: is being done

Used to convey a constant state of the verb being done, executed, etc. It is continuing to exist in a specific state.

> [!info] Example
>今ラーメンを食べ==ています==。
>I am eating ramen now.

#### 2/ State of existence: has been done

Expresses "existing in a of state of having been done".
In English, a different tense would have been used, but in Japanese it is also Te-form.

> [!info] Examples
> お前はもう死==んでいる==。
> You are already dead.
> 
> クラスは始ま==っている==。
> The class has already started. (existing in the state of having started)
> 
> お母さんは今買い物に行==っています==。
> My mom went out to go shopping. (existing in the state of having gone)
> 
> 先生がめちゃ{怒|おこ}==っている==。
> My teacher is very angry. (existing in the state of having gotten angry)

Then, how to differentiate from the past form? Think about if the action can happen twice. For example, something cannot start twice, so it will use ている. The same applies for dying. This will not work for all verbs, but for the majority.

> [!info] Example
> ピアノが{落|お}ち==ている==。
> The piano has fallen. (existing in the state of having fallen)
> Something has fallen and is already on the ground, so it cannot fall again. ている will be used.

#### 3/ State of existence: frequent and repeated action

Used for the repetition of common activities. They are not continuing per se, but are occurring at such a frequency that they are considered to be continuous.
For example: going to work, having a hobby, doing sports, etc.

You can see it as "continuing to exist in a specific state".
Expression of time are often used with this meaning.

> [!info] Examples
> 私は毎日ギターを{弾|ひ}い==ている==。
> I play my guitar everyday (hobby).
> 
> {毎晩|まい|ばん}９時に{寝|ね}==ている==。
> I sleep at 9 every night (habit).
> 
> {彼|かれ}は学校で{働|はたら}い==ている==。
> He works at a school (regular activity).

### ていた・ていました

Means that something was happening, someone was doing something. If an object has changed state and is still in the state, it can also be used, for example a broken window.
Only for **verbs**.

ていた can be shortened to てた, and ていました to てました.

> [!info] Example
> {勉強|べんきょう}をし==ていた==けど、今は{休|やす}んでいる。
> I was studying but am taking a break right now.

### てある

Shares with ている the meaning of being in an ongoing state, meaning that something has been done. It is also similar to a simple past form. However, the nuance is that this form is only used with transitive verbs on inanimate objects, meaning either:
* the action has been done intentionally (focuses on a person's intention),
* the focus is the resulting state of the action.

> [!info] Examples
> 明日の{弁当|べん|とう}はもう作==ってある==。
> Tomorrow's lunch has already been prepared.
> 
> ドアが{開|あ}け==てある==。
> The door has been left open (intentionally).

Only for **transitive verbs**.

### ておく

Means to do something in advance, to complete something in preparation for something.
If used in past form ておいた, means that the completed action was in preparation for the current situation.
Only for **verbs**.

Can be shortened as とく.

> [!info] Example
> メロンパンを買==っておく==。
> I'll buy a melon pan (in preparation for a something, for example a picnic).

### まだ～ていません

This means "still have not done something". 
Only for **verbs**.

> [!info] Example
> このゲームは==まだ==し==ていない==。
> I haven't played this game yet.
