# 3- Te-Form - manner of doing - give & receive

## Manner of doing

### てしまう

<div class="usage">
<div>
	<p><span class="box">Vて</span> + しまう</p>
	<p><span class="box">V<strike>て</strike></span> + ちゃう</p>
	<p><span class="box">V<strike>で</strike></span> + じゃう</p>
</div>
</div>

This means "by accident, unfortunately" or "completely".
Only for **verbs**.

> [!info] Examples
> {宿題|しゅく|だい}もうや==ってしまいました==。
> I've already finished my homework.
> 
> もう{全部|ぜん|ぶ}食べ==ちゃった==。。。
> I've already eaten everything...

### てみる

Used to express the meaning of trying something, usually something new.
Can also be used to suggest to someone to try something.
Used in past tense, it implies a successful attempt.
Only for **verbs**.

> [!info] Example
> これを食べ==てみる==か？
> Do you want to try this food?

### ていく・てくる

ていく combines the Te-form with the verb 行く.
てくる combines the Te-form with the verb 来る. 
Both can be used when representing time or a physical place. Kanji and hiragana can be used, and they can be conjugated.
Only for **verbs**.

The first meaning is the following:
* ていく means to go and do something.
* てくる means to do and come back.

> [!info] Examples
> 家で食べ==ていく==か？
> Want to go and eat at my home?
> 
> {晩御飯|ばんごはん}を買==ってきた==。
> I brought tonight's dinner. (bought and came with).

The second meaning is:
* ていく means to start doing something with your own agency.
* てくる on the contrary, is when something comes to the listener without agency from them.

> [!info] Examples
> 彼は駅まで歩い==ていきます==。
> He walk to the station.
> 
> 雨が{降|ふ}==ってきた==。
> It started raining.

## Give and receive

Extends the common forms of あげる, くれる, and もらう, but what is received or given is now a verb, instead of a noun.

### てあげる

Expresses that someone is doing or did something for someone else.
The person that received the favor is followed by the に particle.
Only for **verbs**.

> [!info] Example
> 母にケーキを買==ってあげた==。
> I bought a cake for my mother.
> 

### てくれる

Used to ask a favor from someone or to say that something was done to the speaker.
The person that received the favor (usually oneself and thus omitted) is followed by the に particle.
Only for **verbs**.

> [!info] Example
> {友達|とも|だち}がギターを{教|おし}え==てくれる==。
> My friend will teach me the guitar.

#### てくれてありがとう

This form expresses gratitude for something that benefited the speaker. It is not used for something expected.
Only for **verbs**.

> [!info] Example
> 今日来==てくれてありがとう==！
> Thank you for coming today!

### てもらう

This form expresses gratitude for a favor that the recipient generally requested for, or where gratitude is the focus.
Only for **verbs**.

> [!info] Example
> {友達|とも|だち}が手伝==ってもらった==。
> My friend helped me (and I owe him / because I asked him and I am grateful)

### てくれない・てもらえない

Used as a mean to ask for a favor like "would you, could you?". Used in a similar form to じゃないか.
Only for **verbs**.

> [!info] Example
> {電気|でん|き}をつけ==てもらえない==か。
> Could you please turn on the lights?
> 
> 電気をつけ==ないでもらえない==か。
> Could you please turn off the light?
