# Japanese Grammar

Welcome to my Japanese Grammar project!

## Goal

The goal of this website is to be a synthesis of useful resources for my Japanese learning adventure. I want to have grammar points next to each other, independently of any "difficulty level", set up in a logical and consistent form. I don't want to have to open 5 pages to compare information, and I don't want a deep dive into a notion. The goal is to be a reminder of the things I learn, rather than a way to learn. I want a few examples to grasp it, but I do not want to have ten of the same kind. And nothing quite fits for me!

## Sources

Of course, since I'm _learning_ the language, I need to borrow what I write from different sources. So this website uses data from the websites listed here. I don't want any recognition of what is here! It's mostly a compilation of what people who are way better in this language have made before.

* [Bunpro](https://bunpro.jp/grammar_points)
* [JLPT Sensei](https://jlptsensei.com/#jlpt-grammar-lists)
* [Maggie Sensei](https://maggiesensei.com/)
* [Try! Series of books](https://2024.ask-books.com/tag/try/)
* [Hedgehog Japanese](https://hedgehog-japanese.com/category/grammar/)
* [Wasabi](https://www.wasabi-jpn.com/category/japanese-grammar/)
* [Japanese StackExchange](https://japanese.stackexchange.com/)
* [Guide du Japonais](https://guidedujaponais.fr/)

## Other useful resources

In addition to those I cited, here are other resources I find useful.

### Kanjis

* [Remembering the Kanji (RTK)](https://en.wikipedia.org/wiki/Remembering_the_Kanji_and_Remembering_the_Hanzi), a kanji learning method
* [Kanji Koohii](https://kanji.koohii.com/), a website using the RTK method and spaced repetition
* [Remember the JLPT](https://git.marchal.dev/keb/remember-the-JLPT), a tool I made to learn kanjis by JLPT levels

### Reading

* [Sakubun](https://sakubun.xyz/)
* [NHK News Web Easy](https://www3.nhk.or.jp/news/easy/)

### Grammar

* [jtest4you](https://japanesetest4you.com/)
* [Japanese Conjugation Drill](https://drill.marchal.dev)

### Vocabulary

* [Jisho](https://jisho.org/), an online dictionary

## Any errors?

If you find any error, please do contact me! You can find my website in the footer of any page of this website. Thanks!